> For the complete documentation index, see [llms.txt](https://v1-docs.mint.club/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://v1-docs.mint.club/developers/mint.club-javascript-sdk/contract-interaction-react.js/buy-and-sell.md).

# Buy & Sell

## Constants

Following are the constant values used in examples below:

```javascript
export const BIG_TEN = new BigNumber(10);
export const DEFAULT_TOKEN_DECIMAL = 18;
```

## Buy

Buy contract call is as follows:

```javascript
mintClubBondContract.buy(
    tokenAddress,
    amount,
    minReward,
    beneficiary,
);
```

In order to calculate the minReward, we utilize the `getMintReward` function from `mintClubBondContract`.

```javascript
const contract = getMintClubBondContract();
const result = await contract.getMintReward(
  tokenAddress,
  truncateDecimals(new BigNumber(mintAmount).times(BIG_TEN.pow(DEFAULT_TOKEN_DECIMAL)).toString(), 0),
); // here mintAmount is amount of mint user is willing to spend

const outBN = new BigNumber(result[0].toString());
const minReward = truncateDecimals(
  outBN
    .times((100 - 2 /* slippage percentage */) / 100)
    .toFixed(0, 1)
    .toString(10),
  0,
);
```

`truncateDecimals` is a number helper function:

```javascript
export function truncateDecimals(num, digits = 18) {
  const str = num?.toString();

  if (str?.includes('.')) {
    const numbers = str.split('.');
    const decimals = numbers[1];
    if (digits === 0) {
      return numbers[0];
    } else if (decimals.length > digits) {
      return `${numbers[0]}.${numbers[1].toString().substring(0, digits)}`;
    }

    return num;
  }

  return num;
}
```

With the calculated values, we can now call the contract:

```javascript
import { AddressZero } from '@ethersproject/constants'; // use null address if there is no referrer wallet address
const tx = await mintClubBondContract.buy(tokenAddress, buyAmount, minReward, referrerWalletAddress);
```

## Sell

Sell contract call is as follows:

```javascript
mintClubBondContract.sell(
    tokenAddress,
    amount,
    minRefund, 
    beneficiary,
);
```

In order to calculate the minRefund, we utilize the `getBurnRefund` function from `mintClubBondContract`.

```javascript
const contract = getMintClubBondContract();
const result = await contract.getBurnRefund(
  tokenAddress,
  new BigNumber(amount).times(BIG_TEN.pow(DEFAULT_TOKEN_DECIMAL)).toString(),
); // here amount is amount of token user is willing to sell

const outBN = new BigNumber(result[0].toString());
const minRefund = outBN
                .times((100 - 2 /* slippage percentage */) / 100)
                .toFixed(0, 1)
                .toString(10);
```

With the calculated `minRefund` value, we can now call the sell function on `mintClubBondContract`.

```javascript
import { AddressZero } from '@ethersproject/constants'; // use null address if there is no referrer wallet address
const tx = await mintClubBondContract.sell(tokenAddress, sellAmount, minRefund, referrerWalletAddress);
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://v1-docs.mint.club/developers/mint.club-javascript-sdk/contract-interaction-react.js/buy-and-sell.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
